#include "stdafx.h"
#include "resource.h"
#include "MenuData.h"
#include "ConfigManager.h"
#include "main.h"
#include "lfutil.h"

void CConfigManager::LoadConfig(BOOL bRightDrag,BOOL bForceExtra)
{
	//ϐ
	ZeroMemory(&ShellMenu,sizeof(ShellMenu));
	ZeroMemory(&DragMenu,sizeof(DragMenu));
	bUnderSubMenu=false;

	CPath strIniPath;
	GetDefaultFilePath(strIniPath,_T("LhaForge.ini"));

	dprintf(_T("Common-> IniPath=%s\n"),(LPCTSTR)strIniPath);

//---------------------------------------------------
	//gj[𗘗p邩ǂ
	bExtraMenu = bForceExtra || GetPrivateProfileInt(_T("ExtraMenu"),_T("ForceExtraMenu"),0,strIniPath);

	if(bRightDrag){
		//--------------------
		// EhbOj[
		//--------------------
		//k
		DragMenu.bCompress=GetPrivateProfileInt(_T("DragMenu"),_T("Compress"),1,strIniPath);
		//k
		DragMenu.bExtract=GetPrivateProfileInt(_T("DragMenu"),_T("Extract"),1,strIniPath);
		//------------------------------
		// Tuj[ȉɕ荞ށH
		//------------------------------
		//LE
		bUnderSubMenu=GetPrivateProfileInt(_T("DragMenu"),_T("UnderSubMenu"),0,strIniPath);
	}else{
		//--------------------
		// ENbNj[
		//--------------------
		//k
		ShellMenu.bCompress=GetPrivateProfileInt(_T("ShellMenu"),_T("Compress"),1,strIniPath);
		//
		ShellMenu.bExtract=GetPrivateProfileInt(_T("ShellMenu"),_T("Extract"),1,strIniPath);
		//{
		ShellMenu.bList=GetPrivateProfileInt(_T("ShellMenu"),_T("List"),1,strIniPath);
		//Ɍ
		ShellMenu.bTestArchive=GetPrivateProfileInt(_T("ShellMenu"),_T("Test"),1,strIniPath);
		//------------------------------
		// Tuj[ȉɕ荞ށH
		//------------------------------
		//LE
		bUnderSubMenu=GetPrivateProfileInt(_T("ShellMenu"),_T("UnderSubMenu"),0,strIniPath);
	}

	if(!bExtraMenu&&(ShellMenu.bCompress||DragMenu.bCompress)){
		//JX^j[
		bCustomCompress=GetPrivateProfileInt(_T("CustomMenu"),_T("UseCustom"),0,strIniPath);
		if(bCustomCompress){	//JX^}CYꂽj[g
			GetPrivateProfileString(_T("CustomMenu"),_T("Arrange"),USER_MENU_DEFAULT,szCustomCompress,_MAX_PATH,strIniPath);
		}
	}

	//-----------------
	// XacRettj[
	//-----------------
	//LE
	bXacRett=GetPrivateProfileInt(_T("XacRett"),_T("EnableShellMenu"),0,strIniPath);
	//-----------------
	// B2Ej[
	//-----------------
	//LE
	bB2E=GetPrivateProfileInt(_T("B2E"),_T("EnableShellMenu"),0,strIniPath);

	//----------------------
	// [U[`j[
	//----------------------
	//LE
	UserMenuArray.clear();
	UINT iIndex=0;
	for(;;iIndex++){
		CString strSectionName;
		strSectionName.Format(_T("UserMenu%d"),iIndex);
		if(!UtilCheckINISectionExists(strSectionName,strIniPath)){
			break;
		}
		CUserMenuItem umi={0};
		//LvV
		GetPrivateProfileString(strSectionName,_T("Caption"),strSectionName,umi.Caption,COUNTOF(umi.Caption)-1,strIniPath);
		//p[^
		GetPrivateProfileString(strSectionName,_T("Param"),_T(""),umi.Param,COUNTOF(umi.Param)-1,strIniPath);
		//ENbNŕ\?
		umi.bShellMenu=GetPrivateProfileInt(strSectionName,_T("ShellMenu"),TRUE,strIniPath);
		//EhbOŕ\H
		umi.bDragMenu=GetPrivateProfileInt(strSectionName,_T("DragMenu"),TRUE,strIniPath);
		//\鎞[h
		if( (!bRightDrag && umi.bShellMenu) || (bRightDrag && umi.bDragMenu)){
			UserMenuArray.push_back(umi);
		}
	}

	//B2Ekj[ǂݍ
	CPath strPath;
	B2ECompressMenu.clear();
	GetDefaultFilePath(strPath,_T("B2EMenu.dat"));
	if(!UtilReadMenuDefinitionFile(strPath,B2ECompressMenu)){
		B2ECompressMenu.clear();
	}
}

void CConfigManager::GetDefaultFilePath(CPath &strIniPath,LPCTSTR lpszFile)	//W̐ݒt@C̃pXZbg
{
	const LPCTSTR PROGRAMDIR_NAME=_T("LhaForge");	//ApplicationDataɓƂɕKvȃfBNg
	//const LPCTSTR INI_FILE_NAME=_T("LhaForge.ini");

	//---[U[Ԃŋʂ̐ݒp
	//LhaForgetH_ƓꏊINIΎgp
	{
		TCHAR szPath[_MAX_PATH+1]={0};
		::GetModuleFileName(g_hInstDLL, szPath, _MAX_PATH);	//̃pX擾
		strIniPath=szPath;
		strIniPath.RemoveFileSpec();
		strIniPath.Append(lpszFile);
		if(strIniPath.FileExists()){
			//ʐݒ
			return;
		}
	}
	//CSIDL_COMMON_APPDATAINIΎgp
	{
		TCHAR szPath[_MAX_PATH+1]={0};
		SHGetFolderPath(NULL,CSIDL_COMMON_APPDATA|CSIDL_FLAG_CREATE,NULL,SHGFP_TYPE_CURRENT,szPath);
		strIniPath=szPath;
		strIniPath.Append(PROGRAMDIR_NAME);
		strIniPath.Append(lpszFile);
		if(strIniPath.FileExists()){
			//ʐݒ
			return;
		}
	}

	//--------------------

	//---[U[ʐݒp
	//LhaForgeCXg[tH_ȉɃt@C݂ꍇAgp
	{
		//[U[擾
		TCHAR UserName[UNLEN+1]={0};
		DWORD Length=UNLEN;
		GetUserName(UserName,&Length);

		TCHAR szPath[_MAX_PATH+1]={0};
		::GetModuleFileName(g_hInstDLL, szPath, _MAX_PATH);	//̃pX擾
		strIniPath=szPath;
		strIniPath.RemoveFileSpec();
		strIniPath.Append(UserName);
		strIniPath.Append(lpszFile);

		if(strIniPath.FileExists()){
			return;
		}
	}
	//---ftHg
	//CSIDL_APPDATAINIΎgp:Vistał͂ȊO̓ANZXsɂȂ\
	TCHAR szPath[_MAX_PATH+1]={0};
	SHGetFolderPath(NULL,CSIDL_APPDATA|CSIDL_FLAG_CREATE,NULL,SHGFP_TYPE_CURRENT,szPath);
	strIniPath=szPath;
	strIniPath.Append(PROGRAMDIR_NAME);
	strIniPath.AddBackslash();
	strIniPath.Append(lpszFile);
	return;
}
